;CELTIC major revision 3 by Rodger Weisman
;This software is licensed in accordance to the attached
;ReadMe file, however perverted it may be.
;Main program
;Celtic III Version code
#DEFINE CIIIVR "3.09(s)"
;Lim ver siz:   *******
;
;I've completely forgotten what was and wasn't fixed. That'll be noted
;whenever I get the bug reports back.
;
;
;
;
;
;
;=======================================================================
;DEFINES FOR PROGRAM MANAGEMENT
;===== Debugging modes
CDEBUG       .equ 0  ;predefined to be always on. Will be stripped by final release
ERRSYS       .equ 1  ;1=long, 1!= short

AVARSIZE     .equ 8  ;Celtic's appvar size
;Appvar is constructed in the following manner:
;.dw HookChainAddress   +0
;.db HookChainPage      +2
;.db CFunctionErrSys    +3
;.db PFunctionErrSys    +4
;.db XFunctionErrSys    +5
;.db LinkStatus         +6
;
;Some of these functions may not have been implemented as of this writing
;
;===== Application header
#include "ti83plus.inc"
.org $4000
.db 080h, 00Fh
.db 000h, 000h, 000h, 000h
.db 080h, 012h
.db 001h, 004h
.db 080h, 021h
.db 003h
.db 080h, 031h
.db 009h
.db 080h, 048h
.db "Celtic 3"
.db 080h, 081h
.db 001h
.db 080h, 090h
.db 003h, 026h, 009h, 004h
.db 015h, 045h, 0AAh, 076h
.db 002h, 00Dh, 040h, 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h
.db 0F5h, 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh, 0C9h
.db 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h, 02Ch, 0F4h, 02Dh
.db 073h, 0B4h, 027h, 0C4h, 0A0h, 072h, 054h, 0B9h, 0EAh, 07Ch
.db 03Bh, 0AAh, 016h, 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h
.db 042h, 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh, 0FCh
.db 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h
.db 080h, 07Fh
.db 000h, 000h, 000h, 000h
.db 000h, 000h, 000h, 000h
.db 000h, 000h, 000h, 000h
.db 000h, 000h, 000h, 000h
.db 000h, 000h, 000h, 000h
 jp programstart
 jp CAutoInstall
;OpenLib( compatibility?
;.db 96h, 0E2h
;.dw 100h, LibHookInfo
LibHookInfo:
; jp CAutoInstall
CIIISpriteMask:   ;guaranteed to not require MSB changing here.
.db 00000001b
.db 00000011b
.db 00000111b
.db 00001111b
.db 00011111b
.db 00111111b
.db 01111111b
.db 11111111b
CIIILogicSeries:
 inc b            ;entry to survive instr inc to something equally useless.
 and d
 or  d
 xor d
CIIIDrawLineType:
.db 1
.db 0
.db 2
;=========================================================
;Program control block

#IF CDEBUG = 1
#DEFINE DEBUG .db $CD \ .dw debug0 ; CALL DEBUG
.ECHO "DEBUG MODE ENABLED\n"
#ELSE
#DEFINE DEBUG ;Null define; strip debug call from code
#ENDIF
#DEFINE HALTPROG push af \ in a,(4) \ bit 3,a \ jr nz,$-4 
#DEFCONT  \ in a,(4) \ bit 3,a \ jr z,$-4 \ pop af
#DEFINE SETCAN(adrs) push af \ ld a,$83 \ ld (adrs),a \ pop af
#DEFINE CHKCAN(adrc) push af \ ld a,(adrc) \ cp $83 \ call nz,debug0 \ pop af


_CreateTStrng .equ $4324
_CreateTRList .equ $4312
_CreateVar    .equ $4E70
gbuf          .equ plotsscreen

myflag equ asm_flag1
HitEOF equ 0  ;EOF during getnextline reached
HitSOF equ 1  ;SOF during getprevline reached
HitEOL equ 2  ;End of line encountered
ConEOF equ 3  ;Set if trying to read after HitEOL is set.
gList  equ 4  ;set to enable get list names
DoTest equ 5  ;Run routine without writing data
Hidden equ 6  ;is set if variable is "hidden"
gGroup equ 7  ;set to enable get group name
nflags equ asm_flag2
nexpon equ 0  ;set exponential write
xlcomp equ 1  ;set xlib compatibility status for error system
mode16 equ 2  ;set 16-bit mode for applicable functions
isneg  equ 3  ;set if input number is negative for final conversion
noimg  equ 4  ;set if image is in savesscreen already. Used for passthrough
overw  equ 5  ;set if files should be overwritten if it already exists
xsprt  equ 6  ;if set, do not use xLIB-only sprite buffering routine
strn16 equ 7  ;if set, treat hex strings as words instead of bytes
;appbackupscreen equ $9872 ;used here for debugging w/o ti83plus.inc
temp1  equ appbackupscreen+00
temp2  equ appbackupscreen+02
temp3  equ appbackupscreen+04
temp4  equ appbackupscreen+06
temp5  equ appbackupscreen+08
temp6  equ appbackupscreen+10
temp7  equ appbackupscreen+12
temp8  equ appbackupscreen+14
temp9  equ appbackupscreen+16
tempA  equ appbackupscreen+18
tempB  equ appbackupscreen+20
tempC  equ appbackupscreen+22
SOF    equ appbackupscreen+24  ;2adr,1pg,1buf. start of file
EOF    equ appbackupscreen+28  ;ditto above. end of file
curpos equ appbackupscreen+32  ;... current cursor position. +3=0 if in RAM
page   equ appbackupscreen+36  ;Page number for when exiting or for var in arc
stack  equ appbackupscreen+37  ;2b stack address for restoring at end of prog
pline  equ appbackupscreen+39  ;2adr,1pg,1buf. Position of previously read line
memdel equ appbackupscreen+43  ;2bytes. Amount of data deleted
memins equ appbackupscreen+45  ;2bytes. Amount of data inserted. To be compared.
gSOF   equ appbackupscreen+49  ;4bytes. Address of grouped start of file + page
gEOF   equ appbackupscreen+53  ;4bytes. Address of grouped end of file + page
gSIZE  equ appbackupscreen+57  ;2bytes. Size of the grouped entry
nsize  equ appbackupscreen+59  ;1byte. Size of name entry in OP1. Excludes type
ipart  equ appbackupscreen+60  ;2bytes. Imaginary part to any complex part input
tstrn  equ appbackupscreen+62  ;5bytes. Temporary storage of 5-digit number
cpage  equ appbackupscreen+67  ;1byte. Refers to the currently accessed page
txtind equ appbackupscreen+68  ;2bytes. Holds offset in bytes to start of buffer
txtbuf equ appbackupscreen+70  ;12bytes. Holds data for characters while processing
sc1    equ appbackupscreen+82  ;9bytes, first entry from OP stack
sc2    equ appbackupscreen+91  ;9bytes, second entry from OP stack
sc3    equ appbackupscreen+100 ;9bytes, third entry from OP stack
sc4    equ appbackupscreen+109 ;9bytes, fourth entry from OP stack
var0   equ appbackupscreen+118 ;2bytes, first number popped off of the FPS
var1   equ appbackupscreen+120 ;2bytes, second number popped off of the FPS
var2   equ appbackupscreen+122 ;2bytes, third number popped off of the FPS
var3   equ appbackupscreen+124 ;2bytes, fourth number popped off of the FPS
var4   equ appbackupscreen+126 ;2bytes, fifth number popped off of the FPS
var5   equ appbackupscreen+128 ;2bytes, sixth number popped off of the FPS
var6   equ appbackupscreen+130 ;2bytes, seventh number popped off of the FPS
var7   equ appbackupscreen+132 ;2bytes, eigth number popped off of the FPS
var8   equ appbackupscreen+134 ;2bytes, ninth number popped off of the FPS
var9   equ appbackupscreen+136 ;2bytes, tenth number popped off of the FPS
varA   equ appbackupscreen+138 ;2bytes, eleventh number popped off of the FPS
varB   equ appbackupscreen+140 ;2bytes, twelfth number popped off of the FPS
varC   equ appbackupscreen+142 ;2bytes, thirteenth number popped off of the FPS
varD   equ appbackupscreen+144 ;2bytes, fourteenth number popped off of the FPS
args   equ appbackupscreen+146 ;2bytes, number of arguments placed on the stack
nargs  equ appbackupscreen+148 ;1byte, number of number arguments on the FPS
sargs  equ appbackupscreen+149 ;1byte, number of string arguments on the FPS
rpart  equ appbackupscreen+150 ;2bytes, real part to the number thingie. *sigh*
ostrng equ appbackupscreen+152 ;9bytes, name of the output string
flgadr equ appbackupscreen+161 ;2bytes, address of myflag flag.
cmask  equ appbackupscreen+163 ;1byte, mask for compression stuffs.
tSOF   equ appbackupscreen+164 ;2bytes, temporary spot for SOF juggling
ltype  equ appbackupscreen+166 ;1byte, type of last argument (first OP1)
strlen equ appbackupscreen+167 ;1byte, 0 to 255 length of temporary string
gSOFp  equ appbackupscreen+168 ;4bytes. Address of grouped file neglecting size.
defend equ appbackupscreen+168 ;defines end here for next set of defines.
;WARNING: An interrupt table is located at $9A00, allowing for a maximum
;offset from appbackupscreen to end at $9872 + $018E (+398)

blow  equ defend+1   ;lowest byte
bhigh equ blow+1     ;highest byte
bnull equ bhigh+1    ;byte not used
bttl  equ bnull+1    ;# of bytes on table. 00 = 256
cmeth equ bttl+1     ;compression method #. Whenever it's supported...
size2 equ cmeth+1    ;temporary storage of size bytes
ctbl  equ size2+1    ;start of compression stats table
;
;overlapping addresses for xLIB compat only (few CIII functions running)
;xlib01 equ $98CD   ;for direct debugging purposes (emulator memory map)
xlib01 equ sc2      ;argument memory location for this
xlib02 equ xlib01+2
xlib03 equ xlib02+2
xlib04 equ xlib03+2
xlib05 equ xlib04+2
xlib06 equ xlib05+2
xlib07 equ xlib06+2
xlib08 equ xlib07+2
xlib09 equ xlib08+2
xlib10 equ xlib09+2
xlib11 equ xlib10+2
xlib12 equ xlib11+2
xlib13 equ xlib12+2
xlib14 equ xlib13+2
xlib15 equ xlib14+2

programstart:
; set textinverse,(iy+textflags)  , FD CB 05 DE
 ld (stack),SP
 ld hl,0
 ld (txtind),hl

CelticStart:
 call cleardisplay
;Should output hex of the checksum so changes can be identified.
 ld hl,$4000
 ld de,$0000
 ld bc,$3F00
CelticCheckSum:
 ld a,(hl)
 xor %01101010
 add a,e
 ld e,a
 jr nc,$+3
 inc d
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,CelticCheckSum
 ld (temp1),de
;
 ld hl,CelStart
 call PutS
CelticMain:
 ld hl,CelMenu1a
 call PutS
 ld hl,($9BAC+2)  ;Parser hook location, page # to L
 in a,(6)
 cp l
 ld hl,CelMenu1b
 jr nz,$+5
 ld hl,CelMenu1c
 call PutS
 ld hl,CelMenu1d
 call PutS
CelticStartL:
 call pressanykey
 cp $22       ;key '1'
 jp z,InstallCeltic
 cp $1A       ;key '2'
 jp z,CelticAbout
 cp $12       ;key '3'
 jp z,ProgramStop
 jr CelticStartL

CelticAbout:
 call cleardisplay
 ld hl,CelCom04
 call PutS
 call pressanykey
 jp CelticMain

ProgramStop:
 bcall($4C36)            ;reloadappentryvecs. TASM won't take the long label
 bjump(_JForceCmdNoChar) ;Application exit

;....123456789012345678901234
CelStart:
.db " __ __   ______ __   __ ",$0A
.db "|   |_ |  |  | |     __|",$0A
.db "|__ |_ |_ | _|_|__   __|",$0A
.db "                        ",$0A
.db "APP VERSION ",CIIIVR," ",$01,$0A
.db "BY: RODGER WEISMAN      ",$0A
.DB "   (IAMBIAN ZENITH)     ",$05
CelMenu1a:
.db "------------------------",$0A,0A,$00
CelMenu1b:
.db " 1:INSTALL              ",$0A,$00
CelMenu1c:
.db " 1:UNINSTALL            ",$0A,$00
CelMenu1d:
.db " 2:ABOUT                ",$0A
.db " 3:QUIT                 ",$0A,0A
.db "------------------------",$0A
.db "PRESS NUMKEY TO CONTINUE",$0A,$0A,$00
CelCom01:
.db "INSTALL SUCCESSFUL!     ",$0A
.db "                        ",$0A
.db "DO NOT DELETE ANY FLASH-",$0A
.db "APPLICATIONS BEFORE UN- ",$0A
.db "INSTALLING CELTIC III.  ",$05  ;$05 is the anykey prompt
CelCom02:
.db "SYSTEM HOOKS ARE IN USE,",$0A
.db "WHAT DO YOU DO?         ",$0A
.db "------------------------",$0A
.db "1:OVERWRITE HOOKS       ",$0A
.db "2:CHAIN THE HOOKS       ",$0A
.db "3:ABORT INSTALLER       ",$0A
.db "4:POWER INSTALL         ",$0A
.db "------------------------",$0A,$00
CelCom04:
.db "CELTIC III BY:          ",$0A
.db " IAMBIAN ZENITH         ",$0A
.db "ORIGINAL CONCEPT BY:    ",$0A
.db " DARTH ANDROID          ",$0A
.db "LOTS OF SUPPORT FROM:   ",$0A
.db " UNITED TI              ",$0A
.db "(WWW.UNITEDTI.ORG)      ",$0A
.db "SPECIAL THANKS TO:      ",$0A
.db $20,$22,"BrandonW",$22,$0A,$00

CelCom05:
.db "INSTALLING CELTIC III...",$0A,$00
CelCom07:
.db "CREATING NEW SETTINGS.  ",$0A,$00
CelCom08:
.db "LOCATED OLD SETTINGS.   ",$0A,$00
CelCom0A:
.db "INSTALLATION ABORTED.   ",$05
CelCom0B:
.db "HOOK SETTINGS PRESERVED.",$0A,$00
CelCom0C:
.db "UNINSTALLING CELTIC III ",$0A,$00
CelCom0D:
.db "CELTIC III UNINSTALLED. ",$05
CelCom0E:
.db "NO PRIOR HOOKS EXIST!   ",$0A
.db "WRITING NEW HOOK...     ",$0A,$00
CelCom0F:
.db "RESTORED PREVIOUS HOOKS.",$05

AnyKey:
.db "PUSH KEY TO CONTINUE    ",$0A,$00
NumKey:
.db "PUSH NUMKEY TO SELECT   ",$0A,$00

;Why do I have these definitions here?
;They, like, became obsolete by the time the app came out >.<
Str0:  .db $04,$AA,$09,$00
Str9:  .db $04,$AA,$08    ;using next data type as null terminator
theta: .db $00,$5B,$00,$00
;Except this one. This one's actually very important!
cAVAR: .db appvarobj,$23,$16,"CELTIC"

.echo "InitialCode: "
.echo $-$4000
.echo " bytes ; "

#include "_HKH.z80"  ;hook handler
#include "_STD.z80"  ;subroutines used frequently
#include "_UTL.z80"  ;utility file
#include "_CFN.z80"  ;C3 fn
#include "_PFN.z80"  ;FA fn
#include "_XFN.z80"  ;XL fn
#include "_UFN.z80"  ;Unused

.echo "-------------------------------\n"
.echo "App. CELTIC3 size: "
.echo $-$4000
.echo " bytes.\n"
.echo "-------------------------------\n"


.end
